diff --git a/models_segmentation/LoadBatches.py b/models_segmentation/LoadBatches.py
index 77f438b..e950caf 100755
--- a/models_segmentation/LoadBatches.py
+++ b/models_segmentation/LoadBatches.py
@@ -166,7 +166,7 @@ def distillationImageSegmentationGenerator( images_path , gt_segs_path ,  batch_
     gt_segmentations = glob.glob( gt_segs_path + "*.jpg") +glob.glob( gt_segs_path + "*.png"  ) +  glob.glob( gt_segs_path + "*.jpeg"  )
     gt_segmentations.sort()
 
-    assert len( images ) == len(gt_segmentations)
+    assert len( images ) == len(gt_segmentations) and len(images)> 0
 
     for im , seg in zip(images,gt_segmentations):
 
@@ -257,3 +257,4 @@ def distillationImageSegmentationGenerator( images_path , gt_segs_path ,  batch_
 # m = Models.VGGSegnet.VGGSegnet( 10  , use_vgg_weights=True ,  optimizer='adadelta' , input_image_size=( 800 , 550 )  )
 # m.fit_generator( G , 512  , nb_epoch=10 )
 
+
diff --git a/models_segmentation/Models/ShuffleNet.py b/models_segmentation/Models/ShuffleNet.py
index 369e391..1515b50 100644
--- a/models_segmentation/Models/ShuffleNet.py
+++ b/models_segmentation/Models/ShuffleNet.py
@@ -1,8 +1,8 @@
-from keras.models import *
-from keras.layers import *
-from keras import backend as K
-from keras.initializers import glorot_normal
-
+from tensorflow.keras.models import *
+from tensorflow.keras.layers import *
+from tensorflow.keras import backend as K
+from tensorflow.keras.initializers import glorot_normal
+import numpy as np
 import os
 file_path = os.path.dirname( os.path.abspath(__file__) )
 
@@ -124,3 +124,4 @@ def ShuffleNet(n_classes, input_height=800, input_width=1400,**kwargs):
 	model.outputHeight = outputHeight
 
 	return model
+
diff --git a/models_segmentation/Models/__init__.py b/models_segmentation/Models/__init__.py
index d29ff56..db08df3 100755
--- a/models_segmentation/Models/__init__.py
+++ b/models_segmentation/Models/__init__.py
@@ -9,3 +9,4 @@ import Models.Student_Shufflenet
 import Models.Xception_deeplab
 import Models.Prof_Xception
 import Models.Xception_10layer_output
+import Models.segnet_dropout
\ No newline at end of file
diff --git a/models_segmentation/run_files/augment_proper.sh b/models_segmentation/run_files/augment_proper.sh
deleted file mode 100755
index 1565609..0000000
--- a/models_segmentation/run_files/augment_proper.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/augmentations_fixed.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=400 --val_steps=72 --epochs=50 --train_batch_size=8 --val_batch_size=8 --epochs=300 --model_name=xception --experiment_name="proper_augmentations" --options='{"dropout_rate":0.55, "OS":16, "mid_repeat":8}' --annotation_filter="oldschool" --augment
-
diff --git a/models_segmentation/run_files/break_physics.sh b/models_segmentation/run_files/break_physics.sh
deleted file mode 100644
index 6a3fcd5..0000000
--- a/models_segmentation/run_files/break_physics.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/break_pysics_teacheronly.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=400 --val_steps=72 --epochs=50 --train_batch_size=8 --val_batch_size=8 --model_name=xception --experiment_name="breaking_physics_onlyteacher" --options='{"dropout_rate":0.8, "OS":16, "mid_repeat":8}' --annotation_filter="oldschool" --teacher_annotations="../dataset_current/distilled5/images_train/" --teacher_annotations_val="../dataset_current/distilled5/images_val/" --temp=2 --is_student
diff --git a/models_segmentation/run_files/run_shufflenet.sh b/models_segmentation/run_files/run_shufflenet.sh
index 402a8b8..fb874ae 100644
--- a/models_segmentation/run_files/run_shufflenet.sh
+++ b/models_segmentation/run_files/run_shufflenet.sh
@@ -1,7 +1,7 @@
 #! /bin/bash
-#SBATCH --output=training_console/shufflenet0.txt
+#SBATCH --output=training_console/shufflenet_rmsprop.txt
 
 module load cuda/9.0 anaconda/3
 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-srun python3 train.py --train_steps=97 --epochs=300 --model_name="shufflenet" --experiment_name="shufflenet_optimal" --options='{"decoder_size":1, "num_shuffle_units":[3,4], "scale_factor":0.5, "bottleneck_ratio":1.0,"groups":2}'
 
+srun python3 train.py --train_steps=97 --epochs=300 --model_name="shufflenet" --experiment_name="shufflenet_rmsprop" --optimizer_name="rmsprop" --options='{"decoder_size":1, "num_shuffle_units":[2,5], "scale_factor":0.5, "bottleneck_ratio":1.0,"groups":2}'
diff --git a/models_segmentation/run_files/run_vgg_plain.sh b/models_segmentation/run_files/run_vgg_plain.sh
index 371abf5..8a13f56 100644
--- a/models_segmentation/run_files/run_vgg_plain.sh
+++ b/models_segmentation/run_files/run_vgg_plain.sh
@@ -1,8 +1,7 @@
 #! /bin/bash
-#SBATCH --output=training_console/plain_vgg.txt
+#SBATCH --output=training_console/segnet_Adam.txt
+module load anaconda/3
 
-module load cuda/9.0 anaconda/3
 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
 
-srun python3 train.py --train_steps=97 --epochs=300 --model_name=vgg_segnet_hacked_channelslast --experiment_name="vgg_debug" --annotation_filter="oldschool"
-~
+srun python3 train.py --train_steps=110 --epochs=400 --model_name=vgg_segnet_hacked_channelslast --experiment_name="optimizer" --annotation_filter="oldschool" --val_steps=20 --optimizer_name="Adam"
diff --git a/models_segmentation/run_files/train_teacher.sh b/models_segmentation/run_files/train_teacher.sh
deleted file mode 100644
index bf10b80..0000000
--- a/models_segmentation/run_files/train_teacher.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/train_teacher.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=400 --val_steps=72 --epochs=400 --train_batch_size=8 --val_batch_size=8 --model_name=prof_xception --experiment_name="train_teacher_xception_temp3" --options='{"dropout_rate":0.55, "OS":16, "mid_repeat":8, "temp":3}' --annotation_filter="oldschool" --temp=3
diff --git a/models_segmentation/run_files/train_teacher2.sh b/models_segmentation/run_files/train_teacher2.sh
deleted file mode 100644
index d17a270..0000000
--- a/models_segmentation/run_files/train_teacher2.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/train_teacher2.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=400 --val_steps=72 --epochs=400 --train_batch_size=8 --val_batch_size=8 --model_name=prof_xception --experiment_name="train_teacher_xception_temp2" --options='{"dropout_rate":0.55, "OS":16, "mid_repeat":8, "temp":2}' --annotation_filter="oldschool" --temp=2
diff --git a/models_segmentation/run_scripts/augment_proper.sh b/models_segmentation/run_scripts/augment_proper.sh
deleted file mode 100755
index 1565609..0000000
--- a/models_segmentation/run_scripts/augment_proper.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/augmentations_fixed.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=400 --val_steps=72 --epochs=50 --train_batch_size=8 --val_batch_size=8 --epochs=300 --model_name=xception --experiment_name="proper_augmentations" --options='{"dropout_rate":0.55, "OS":16, "mid_repeat":8}' --annotation_filter="oldschool" --augment
-
diff --git a/models_segmentation/run_scripts/break_physics.sh b/models_segmentation/run_scripts/break_physics.sh
deleted file mode 100644
index 6a3fcd5..0000000
--- a/models_segmentation/run_scripts/break_physics.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/break_pysics_teacheronly.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=400 --val_steps=72 --epochs=50 --train_batch_size=8 --val_batch_size=8 --model_name=xception --experiment_name="breaking_physics_onlyteacher" --options='{"dropout_rate":0.8, "OS":16, "mid_repeat":8}' --annotation_filter="oldschool" --teacher_annotations="../dataset_current/distilled5/images_train/" --teacher_annotations_val="../dataset_current/distilled5/images_val/" --temp=2 --is_student
diff --git a/models_segmentation/run_scripts/run_benchmark.sh b/models_segmentation/run_scripts/run_benchmark.sh
deleted file mode 100644
index 268b6e1..0000000
--- a/models_segmentation/run_scripts/run_benchmark.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/benchmark.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 armand_benchmark.py --model_file="selected_trained_models/weights-improvement-380-0.9496-0.0668.hdf5"
diff --git a/models_segmentation/run_scripts/run_conv_imgs.sh b/models_segmentation/run_scripts/run_conv_imgs.sh
deleted file mode 100644
index 8cf9b40..0000000
--- a/models_segmentation/run_scripts/run_conv_imgs.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/convert_imgs_temp2.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 convert_predictions_to_image.py --model_file=weights/train_teacher_xception_temp2/prof_xception__id4118/weights-improvement-268-0.1174.hdf5 --output_folder=../dataset_current/distilled3/
diff --git a/models_segmentation/run_scripts/run_pruning.sh b/models_segmentation/run_scripts/run_pruning.sh
deleted file mode 100644
index b23825a..0000000
--- a/models_segmentation/run_scripts/run_pruning.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/pruning_student_shufflenet.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 pruning.py --model_type='shufflenet' --epochs=200 --pruning_iterations=5 --method="apoz" --is_student
diff --git a/models_segmentation/run_scripts/run_pruning2.sh b/models_segmentation/run_scripts/run_pruning2.sh
deleted file mode 100644
index b7f28a6..0000000
--- a/models_segmentation/run_scripts/run_pruning2.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/pruning_vgg.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 pruning.py --model_type='vgg' --epochs=200 --pruning_iterations=5 --method="apoz"
diff --git a/models_segmentation/run_scripts/run_pruning_quick.sh b/models_segmentation/run_scripts/run_pruning_quick.sh
deleted file mode 100644
index 5f7f81b..0000000
--- a/models_segmentation/run_scripts/run_pruning_quick.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/pruning_quick.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 pruning.py --model_type='vgg' --epochs=50
diff --git a/models_segmentation/run_scripts/run_shufflenet2.sh b/models_segmentation/run_scripts/run_shufflenet2.sh
deleted file mode 100644
index f80c8b3..0000000
--- a/models_segmentation/run_scripts/run_shufflenet2.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/shufflenet1.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-srun python3 train.py --train_steps=97 --epochs=300 --model_name="shufflenet" --experiment_name="shufflenet_optimal" --options='{"decoder_size":1, "num_shuffle_units":[2,2], "scale_factor":0.5, "bottleneck_ratio":0.5}'
-
diff --git a/models_segmentation/run_scripts/run_shufflenet3.sh b/models_segmentation/run_scripts/run_shufflenet3.sh
deleted file mode 100644
index 8fba0ab..0000000
--- a/models_segmentation/run_scripts/run_shufflenet3.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/shufflenet0.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=97 --epochs=300 --model_name="shufflenet" --experiment_name="shufflenet_optimal" --options='{"decoder_size":2, "num_shuffle_units":[2,1,1], "scale_factor":0.5, "bottleneck_ratio":1.0,"groups":2}'
-
diff --git a/models_segmentation/run_scripts/run_temp1.sh b/models_segmentation/run_scripts/run_temp1.sh
deleted file mode 100755
index 94904cf..0000000
--- a/models_segmentation/run_scripts/run_temp1.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/temperature1.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=97 --epochs=300 --model_name=shufflenet --experiment_name="student_shufflenet" --options='{"decoder_size":2, "num_shuffle_units":[1,3,1], "bottleneck_ratio":1.0,"scale_factor":0.5}' --annotation_filter="oldschool" --teacher_annotations="../dataset_current/distilled1/images_train/" --temp=1
-
diff --git a/models_segmentation/run_scripts/run_temp5.sh b/models_segmentation/run_scripts/run_temp5.sh
deleted file mode 100755
index 8322057..0000000
--- a/models_segmentation/run_scripts/run_temp5.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/temperature5.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=97 --epochs=300 --model_name="vgg_segnet_hacked_channelslast" --experiment_name="vgg_distilled_both" --temp=5 --is_student
diff --git a/models_segmentation/run_scripts/run_vgg_onlyteacher.sh b/models_segmentation/run_scripts/run_vgg_onlyteacher.sh
deleted file mode 100644
index fd48d72..0000000
--- a/models_segmentation/run_scripts/run_vgg_onlyteacher.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/temperature5_vgg.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --model_name=vgg_segnet_hacked_channelslast --experiment_name="student_vgg" --annotation_filter="oldschool" --temp=5 --is_student
diff --git a/models_segmentation/run_scripts/run_vgg_temp5.sh b/models_segmentation/run_scripts/run_vgg_temp5.sh
deleted file mode 100644
index 147145f..0000000
--- a/models_segmentation/run_scripts/run_vgg_temp5.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/temperature5_vgg.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=97 --epochs=300 --model_name=vgg_segnet_hacked_channelslast --experiment_name="student_vgg" --annotation_filter="oldschool" --teacher_annotations="../dataset_current/distilled5/images_train/" --teacher_annotations_val="../dataset_current/distilled5/images_val/" --temp=5 --is_student
diff --git a/models_segmentation/run_shufflenet.sh b/models_segmentation/run_shufflenet.sh
deleted file mode 100644
index 4408d10..0000000
--- a/models_segmentation/run_shufflenet.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/shufflenet_9.1.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python2 train.py --train_steps=97 --epochs=300 --model_name="shufflenet" --experiment_name="shufflenet_9.1" --options='{"decoder_size":1, "num_shuffle_units":[2,5], "scale_factor":0.5, "bottleneck_ratio":1.0,"groups":2}'
diff --git a/models_segmentation/run_vgg_plain.sh b/models_segmentation/run_vgg_plain.sh
deleted file mode 100644
index 051b3d3..0000000
--- a/models_segmentation/run_vgg_plain.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/segnet_9.1.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python2 train.py --train_steps=110 --epochs=400 --model_name=vgg_segnet_hacked_channelslast --experiment_name="segnet_8.1" --annotation_filter="oldschool" --val_steps=20
-~
diff --git a/models_segmentation/testparams.txt b/models_segmentation/testparams.txt
deleted file mode 100644
index dcdf3f0..0000000
--- a/models_segmentation/testparams.txt
+++ /dev/null
@@ -1 +0,0 @@
-48 is the outputwidth
\ No newline at end of file
diff --git a/models_segmentation/train.py b/models_segmentation/train.py
index 8668281..b063b9f 100644
--- a/models_segmentation/train.py
+++ b/models_segmentation/train.py
@@ -1,12 +1,13 @@
 import argparse
 import Models , LoadBatches
 import metrics_and_losses
+import tensorflow as tf
+
 from tensorflow.python.keras.models import load_model
 from tensorflow.python.keras.models import Model 
 from tensorflow.python.keras.layers import Lambda, Concatenate, Activation
 from tensorflow.python.keras.callbacks import TensorBoard, ModelCheckpoint
 from time import time
-import tensorflow as tf
 import numpy as np
 from tensorflow.python.keras import backend as K
 import matplotlib.pyplot as plt
@@ -15,6 +16,9 @@ import json
 import random
 import augmentation_functions as aug
 
+import loadDataset
+
+
 #print "this script currently runs with python2"
 
 from datetime import datetime
@@ -29,6 +33,7 @@ parser.add_argument("--n_classes", type=int , default=2)
 parser.add_argument("--input_height", type=int , default = 130  )
 parser.add_argument("--input_width", type=int , default = 384 )
 parser.add_argument("--experiment_name", type=str, required=True)
+parser.add_argument("--run_name", type=str, default="")
 parser.add_argument("--annotation_filter", type=str, default="oldschool", help="values can be smoothed, dilated or oldschool")
 
 parser.add_argument("--train_images", type = str, default="../dataset_current/dataset_own_v9.1/images_train/"  )
@@ -49,17 +54,28 @@ parser.add_argument("--optimizer_name", type = str , default = "adadelta")
 parser.add_argument("--loss_name", type = str , default = "categorical_crossentropy")
 parser.add_argument("--image_normalization", type = str , default = "sub_mean")
 parser.add_argument("--augment", action="store_true", default=False)
+parser.add_argument("--zoom_intensity", type = float, default = 0.2 )
+parser.add_argument("--flip_horizontal", action="store_true", default=False)
+
 parser.add_argument("--options", type=str, default="{}")
 parser.add_argument("--temp", type=int, default=5)
 parser.add_argument("--is_student", action="store_true", default=False)
 
 args = parser.parse_args()
+#wandb
+import wandb
+from wandb.keras import WandbCallback
+wandb.init(project="lawnrobot", name=args.run_name, group =args.experiment_name)
+
+wandb.config.update(args)
+
 
 print("INFO: train_steps x train_batch_size should be greater than the dataset")
 
 modelFns = { 
  
   'vgg_segnet_hacked_channelslast':Models.VGGSegnet_hacked_channelslast.VGGSegnet,
+  'segnet_dropout':Models.segnet_dropout.SegmentationModel,
   'mobile_net_v1':Models.Mobile_Net_v1.MobileNet,
   'mobile_net_v1_small': Models.Mobile_Net_v1_small.MobileNet,
   'mobile_net_v2':Models.Mobile_Net_v2.MobileNet,
@@ -97,7 +113,7 @@ else:
   # metrics = ['acc']
   custom_objects = {"iou_score" : metrics_and_losses.iou_score,  
             "iou_score_student_hard" : metrics_and_losses.iou_score_student_hard,}
-  custom_objects = {}
+  # custom_objects = {}
 
 if(args.loss_name not in locals().keys()):
     loss_fn = args.loss_name
@@ -139,36 +155,64 @@ print(m.summary())
 
 ''' 
     The ranges of intensity values that would make sense:
-    zoom: 0 - 0.5
+    zoom: 0 - 0.25
     shear: 0 - 30
     rotation: 0 - 30
     brightness: 0 - 0.3 
     hue: 0 - 0.3
     saturation: 0 - 0.3
 
-    which fill_mode to use in spatial transformations?? 
-
-
-augmentations = [random_zoom, random_shear, random_rotation, 
-                 random_brightness, random_hue, random_saturation, flip_axis]
-
-intensities = [0.3, 20, 20,
-               0.2, 0.2, 0.2, 0]
-
 '''
-
+ 
 if (args.augment):
-  augmentations=[aug.random_zoom, aug.random_shear, aug.random_rotation, aug.flip_axis]
-  intensities = [0.07, 0.07, 0.07, -1]
+  # augmentations=[aug.random_zoom, aug.random_shear, aug.random_rotation, aug.flip_axis]
+
+  if(args.flip_horizontal):
+    augmentations=[aug.random_zoom, aug.flip_axis]
+    intensities = [args.zoom_intensity, -1]
+  else:
+    augmentations=[aug.random_zoom]
+    intensities = [args.zoom_intensity]
+
 else:
   augmentations=[]
   intensities=[]
 
-train_generator = LoadBatches.distillationImageSegmentationGenerator(
-        images_path = args.train_images , 
-        gt_segs_path = args.train_annotations , 
-        batch_size = args.train_batch_size,  
-        n_classes = args.n_classes, 
+# train_generator = LoadBatches.distillationImageSegmentationGenerator(
+#         images_path = args.train_images , 
+#         gt_segs_path = args.train_annotations , 
+#         batch_size = args.train_batch_size,  
+#         n_classes = args.n_classes, 
+#         input_height = args.input_height , input_width =  args.input_width , 
+#         output_height = m.outputHeight , output_width = m.outputWidth, 
+#         imgNorm = args.image_normalization,
+#         augmentations = augmentations, 
+#         intensities = intensities, 
+#         annotation_filter = args.annotation_filter,
+#         teacher_segs_path = args.teacher_annotations, 
+#         is_student=args.is_student,
+#         train_steps=args.train_steps)
+
+# validation_generator = LoadBatches.distillationImageSegmentationGenerator(
+#         images_path = args.val_images , 
+#         gt_segs_path = args.val_annotations,
+#         batch_size = args.val_batch_size, 
+#         n_classes = args.n_classes , 
+#         input_height = args.input_height , input_width = args.input_width, 
+#         output_height = m.outputHeight , output_width = m.outputWidth,
+#         imgNorm = args.image_normalization, 
+#         intensities = [], 
+#         augmentations = [], 
+#         annotation_filter = args.annotation_filter,
+#         teacher_segs_path = args.teacher_annotations_val,
+#         is_student= args.is_student,
+#         train_steps=args.val_steps)
+
+train_dataset, val_dataset = loadDataset.load_dataset(
+        train_images_path = args.train_annotations , 
+        val_images_path = args.val_annotations , 
+        BATCH_SIZE = args.train_batch_size,  
+        nClasses = args.n_classes, 
         input_height = args.input_height , input_width =  args.input_width , 
         output_height = m.outputHeight , output_width = m.outputWidth, 
         imgNorm = args.image_normalization,
@@ -176,24 +220,9 @@ train_generator = LoadBatches.distillationImageSegmentationGenerator(
         intensities = intensities, 
         annotation_filter = args.annotation_filter,
         teacher_segs_path = args.teacher_annotations, 
-        is_student=args.is_student,
-        train_steps=args.train_steps)
-
-validation_generator = LoadBatches.distillationImageSegmentationGenerator(
-        images_path = args.val_images , 
-        gt_segs_path = args.val_annotations,
-        batch_size = args.val_batch_size, 
-        n_classes = args.n_classes , 
-        input_height = args.input_height , input_width = args.input_width, 
-        output_height = m.outputHeight , output_width = m.outputWidth,
-        imgNorm = args.image_normalization, 
-        intensities = [], 
-        augmentations = [], 
-        annotation_filter = args.annotation_filter,
-        teacher_segs_path = args.teacher_annotations_val,
-        is_student= args.is_student,
-        train_steps=args.val_steps)
+        is_student=args.is_student)
 
+print(train_dataset.take(5))
 
 #create txt file and store all info about this training run
 random_id = "_id" + str(random.randint(0, 10000))
@@ -210,13 +239,18 @@ with open(weights_path_name + "/model_summary.txt", 'w') as outfile:
 with open(weights_path_name + "/options.txt", 'w') as outfile:  
     outfile.write(args.options)
 
+# table = wandb.Table(columns=["key", "value"])
+# for a in args:
+#   table.add(a)
+# wandb.log({"args": table})
+
 tbcallback = TensorBoard(log_dir="logs/" + args.experiment_name + "/" + unique_folder_name,
                          histogram_freq=0, write_graph=True, write_images=True)
 
-filepath=weights_path_name + "weights-improvement-{epoch:02d}-{val_loss:.4f}-{val_iou_score_student_hard}.hdf5"
-# filepath=weights_path_name + "weights-improvement-{epoch:02d}.hdf5"
+filepath=weights_path_name + "weights-improvement-{epoch:02d}-{val_loss:.4f}-{val_iou_score_student_hard:04f}.hdf5"
 
 # checkpoint = ModelCheckpoint(filepath, monitor='val_acc', save_best_only=False, mode="max")
+filepath = os.path.join(wandb.run.dir, "model.h5")
 checkpoint = ModelCheckpoint(filepath, monitor='val_iou_score_student_hard', verbose=1, save_best_only=True, mode='max')
 
 '''             TODO 
@@ -225,7 +259,7 @@ checkpoint = ModelCheckpoint(filepath, monitor='val_iou_score_student_hard', ver
     reduces overhead for inference
 '''
 
-callbacks_list = [checkpoint, tbcallback]
+callbacks_list = [checkpoint, tbcallback, WandbCallback()]
 # callbacks_list = [checkpoint]
 
 #ceck dataset
@@ -235,18 +269,24 @@ assert(len(im_tempfiles_train) == len(an_tempfiles_train) and len(im_tempfiles_t
 
 #only evaluate if epochs==0
 if(args.epochs==0):
-  history = m.evaluate_generator(validation_generator, steps=args.val_steps, verbose=1, callbacks=callbacks_list)
+  history = m.evaluate(val_dataset.take(args.val_steps), 
+  # history = m.evaluate_generator(val_dataset.take(args.val_steps), 
+                                # steps=args.val_steps,  
+                                verbose=1, callbacks=callbacks_list)
+
   results = list(zip(m.metrics_names, history))
   for r in results:
     print(r)
 
 else:
   try:
-    history = m.fit_generator( train_generator , args.train_steps  , 
-          validation_data=validation_generator , 
-          validation_steps=args.val_steps ,  
+    history = m.fit( train_dataset.take(args.train_steps), 
+    # history = m.fit( train_generator , args.train_steps, 
+          # validation_data=val_dataset.take(args.val_steps), 
+          # validation_data=validation_generator , 
+          # validation_steps=args.val_steps ,  
           epochs=args.epochs , 
-          callbacks=callbacks_list)
+          callbacks=callbacks_list, use_multiprocessing=False)
 
   except StopIteration:
     print("Training could not start, check your file path!\n")
@@ -255,3 +295,94 @@ else:
           os.unlink(weights_path_name + "/model_summary.txt")
           os.rmdir(weights_path_name)
       print ("\n Ouch!")
+
+
+# #### visualize selected image for wandb platform
+# def visualize_outputs(m, images_path)
+#     annotations_path = args.annotations
+#     segmentation_timer = []
+#     loss_sum = []
+#     iou_sum = []
+#     hard_iou_sum = []
+
+#     sub_dir_path = os.path.relpath(os.path.normpath(images_path), os.path.normpath(args.images)) + "/"
+#     # output_file_path = os.path.normpath(error_vis_path + sub_dir_path)
+    
+#     # if(args.save_output):
+#     #     if not os.path.exists(output_file_path):
+#     #         os.makedirs(output_file_path)
+#     counter = 0
+
+#     files = os.listdir(images_path)
+#     pngs = [f for f in files if (".png" in f)]
+#     jpgs = [f for f in files if (".jpg" in f)]
+#     pngs.sort()
+#     jpgs.sort()
+#     if(len(pngs)>0 and len(jpgs)> 0):
+#         #this means the annotations are in the same folder as the images
+#         annotations_path = images_path
+
+    
+#     for imgName in jpgs:
+#         counter +=1
+
+#         if counter == 6:
+#             break
+
+#         img_orig = cv2.imread(images_path + imgName)
+
+#         X = LoadBatches.getImageArr(images_path + imgName , input_width  , input_height )
+
+#         #start measuring time
+#         tic = time.time()
+
+#         if(is_tflitemodel):
+#             input_data = [X]
+#             interpreter.set_tensor(input_details[0]['index'], input_data)
+#             interpreter.invoke()
+
+#             pr = interpreter.get_tensor(output_details[0]['index'])[0]
+
+#         else:
+#             pr = m.predict( np.array([X]) )[0]
+
+#         #stop measuring time
+#         toc = time.time()
+#         segmentation_timer.append(toc-tic)
+
+
+#         inference_ms = str(int(segmentation_timer[-1]*1000))
+#         print(inference_ms + "ms, " + str(counter) + '/' + str(len(jpgs)) + " showing image overview of: " +  imgName)
+
+#         # if(args.visualize or args.save_output):
+#         #     visualize(X, pr, imgName, img_orig, output_file_path, annotations_path, loss_sum, iou_sum, hard_iou_sum, images_path)
+        
+
+
+#     def reject_outliers(data, m=0.5):
+#         filtered = data[abs(data - np.mean(data)) < m * np.std(data)]
+#         print("rejecting", len(data) - len(filtered), "outliers")
+#         return filtered
+
+#     if(not args.visualize):
+#         segmentation_timer = np.array(segmentation_timer)
+#         segmentation_timer = reject_outliers(segmentation_timer)
+
+#         avg_time = str(np.mean(segmentation_timer))
+#         total_time = str(np.sum(segmentation_timer))
+#         print('total segmentation duration for ' + str(counter) + ' images: ' + total_time + ' average: ' + avg_time)
+
+
+#     # else:
+#     #     print("not printing inference speed because visualization is turned on")
+#     # if(args.save_output):
+#     #     #calculate grades per datasubset and rename folder accordingly
+#     #     split_path = os.path.split(os.path.normpath(output_file_path))
+#     #     path_head = split_path[0]
+#     #     path_tail = split_path[1]
+#     #     assert(path_tail != "")
+#     #     renamed_path = path_head + "/"  + path_tail +  "_iou: " + str(np.mean(iou_sum)*100)[:4]
+#     #     print("renaming folder ", output_file_path, "to", renamed_path)
+#     #     os.rename(output_file_path, renamed_path)
+#     #     if(args.is_student):
+#     #         print(np.mean(hard_iou_sum), "is hard iou sum", np.mean(iou_sum), "soft_iou_sum")
\ No newline at end of file
diff --git a/models_segmentation/train_xception.sh b/models_segmentation/train_xception.sh
deleted file mode 100644
index 2da56c3..0000000
--- a/models_segmentation/train_xception.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/bash
-#SBATCH --output=training_console/train_teacher2.txt
-
-module load cuda/9.0 anaconda/3
-export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/ozastrow/cuda/lib64
-
-srun python3 train.py --train_steps=500 --val_steps=80 --epochs=400 --train_batch_size=8 --val_batch_size=8 --model_name=xception --experiment_name="xception_9.1" --options='{"dropout_rate":0.55, "OS":16, "mid_repeat":8, "temp":2}' --annotation_filter="oldschool"
